function varargout = furije(varargin)
% FURIJE Application M-file for furije.fig
%    FIG = FURIJE launch furije GUI.
%    FURIJE('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 21-Oct-2003 16:00:03

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.
global t
global x
global y

%if  ~isempty(x)
%    x=[];
%end

%if  ~isempty(y)
%    y=[];
%end



t=[0:1024];
% --------------------------------------------------------------------
function varargout = slider1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider1.
set(handles.edit1,'String',get(handles.slider1,'Value'));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = slider2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider2.
set(handles.edit2,'String',get(handles.slider2,'Value'));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = slider3_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider3.
set(handles.edit3,'String',get(handles.slider3,'Value'));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = slider4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider1.
set(handles.edit4,'String',get(handles.slider4,'Value'));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = slider5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider1.
set(handles.edit5,'String',get(handles.slider5,'Value'));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = slider6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider1.
set(handles.edit6,'String',get(handles.slider6,'Value'));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------





% --------------------------------------------------------------------
function varargout = edit1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit1.
set(handles.slider1,'Value',str2num(get(handles.edit1,'String')));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = edit2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit2.
set(handles.slider2,'Value',str2num(get(handles.edit2,'String')));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = edit3_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit3.
set(handles.slider2,'Value',str2num(get(handles.edit2,'String')));
popupmenu1_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = edit4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit3.
set(handles.slider4,'Value',str2num(get(handles.edit4,'String')));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = edit5_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit3.
set(handles.slider5,'Value',str2num(get(handles.edit5,'String')));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------
function varargout = edit6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit3.
set(handles.slider6,'Value',str2num(get(handles.edit6,'String')));
popupmenu2_Callback(h, eventdata, handles, varargin)
% --------------------------------------------------------------------













% --------------------------------------------------------------------
function varargout = popupmenu1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.popupmenu1.
global t
global x
global y
global zbir



pop1=get(handles.popupmenu1,'Value');


Amplituda1=get(handles.slider1,'Value');
Perioda1=get(handles.slider2,'Value');
Faza1=get(handles.slider3,'Value');
Prigusenje1=get(handles.slider7,'Value');

switch pop1
case 1
    x=t*.0;
case 2
    x=t*.0;
    %plot(t,x,'Parent',handles.axes1);
case 3    
    P1=exp((-Prigusenje1/100)*t);
    x=P1.*(Amplituda1*sin(t/(Perioda1+0.01)+Faza1));
    %plot(t,x,'Parent',handles.axes1);
case 4
    x = Amplituda1*0.01*randn(size(t));
    %plot(t,x,'Parent',handles.axes1);
case 5
    P1=exp((-Prigusenje1/100)*t);
     x=Amplituda1*sin((Perioda1/100)*t+Faza1);
     for i=1:length(t)
         if x(i)>0
             x(i)=Amplituda1*P1(i);
         else
             x(i)=0;
         end
     end
 case 6
     P1=exp((-Prigusenje1/100)*t);
     x=Amplituda1*sin((Perioda1/100)*t+Faza1);
     for i=1:length(t)
         if x(i)>0
             x(i)=Amplituda1*P1(i);
         else
             x(i)=(-Amplituda1)*P1(i);
         end
     end
 case 7
     x=(Amplituda1/1000)*exp((Perioda1/1000)*t)+(Faza1/100);
 case 8
     x=(Amplituda1/10)*log((Perioda1/10)*t)+(Faza1);
 case 9
        x=t*.0;
     for i=round(Faza1*10):round(Faza1*10+Perioda1*10)
         x(i)=1;
     end
         
end
plot(t,x,'Parent',handles.axes1);
set(handles.axes1,'YLim',[1.1*min(x)-0.1,1.1*max(x)+0.1],'XLim',[0,1024]);



zbir=x+y;
plot(t,zbir,'Parent',handles.axes3);
set(handles.axes3,'YLim',[1.1*min(zbir)-0.1,1.1*max(zbir)+0.1],'XLim',[0,1024]);
% --------------------------------------------------------------------



% --------------------------------------------------------------------
function varargout = popupmenu2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.popupmenu2.

global t
global x
global y
global zbir




pop2=get(handles.popupmenu2,'Value');

Amplituda2=get(handles.slider4,'Value');
Perioda2=get(handles.slider5,'Value');
Faza2=get(handles.slider6,'Value');
Prigusenje2=get(handles.slider8,'Value');

switch pop2
case 1
     y=t*.0;
case 2
    y=t*.0;
    %plot(t,x,'Parent',handles.axes1);
case 3
    P2=exp((-Prigusenje2/100)*t);
    y=P2.*(Amplituda2*sin(t/(Perioda2+0.01)+Faza2));
    %plot(t,x,'Parent',handles.axes1);
case 4
    y= Amplituda2*0.01*randn(size(t));
    %plot(t,x,'Parent',handles.axes1);
case 5
     P2=exp((-Prigusenje2/100)*t);
     y=Amplituda2*sin((Perioda2/100)*t+Faza2);
     for i=1:length(t)
         if y(i)>0
             y(i)=(Amplituda2)*P2(i);
         else
             y(i)=0;
         end
     end
 case 6
        P2=exp((-Prigusenje2/100)*t);
        y=Amplituda2*sin((Perioda2/100)*t+Faza2);
     for i=1:length(t)
         if y(i)>0
             y(i)=(Amplituda2)*P2(i);
         else
             y(i)=(-Amplituda2)*P2(i);
         end
     end
 case 7
     y=(Amplituda2/1000)*exp((Perioda2/1000)*t)+(Faza2/100);
 case 8
     y=(Amplituda2/10)*log((Perioda2/10)*t)+(Faza2);
case 9
        y=t*.0;
     for i=round(Faza2*10):round(Faza2*10+Perioda2*10)
         y(i)=1;
     end
end
plot(t,y,'Parent',handles.axes2);
set(handles.axes2,'YLim',[1.1*min(y)-0.1,1.1*max(y)+0.1],'XLim',[0,1024]);

% ------------------Blok za racunanje zbira signala------------------------------

zbir=x+y;
plot(t,zbir,'Parent',handles.axes3);
set(handles.axes3,'YLim',[1.1*min(zbir)-0.1,1.1*max(zbir)+0.1],'XLim',[0,1024]);

% -----------------------------------------------




% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.radiobutton1.
global zbir
global Dobijeno
global f

Dobijeno=[];
f=[];

set(handles.radiobutton2,'Value',0)
set(handles.radiobutton3,'Value',0)
set(handles.radiobutton4,'Value',0)

% --------------------Blok za racunanje Furijeove transformacije i snage----------------------
furije = fft(zbir,1024);
Snaga = furije.*conj(furije)/1024;
f = 1000*(0:512)/1024;
Dobijeno=Snaga(1:length(f));
semilogy(f,Dobijeno,'Parent',handles.axes4)
% --------------------------------------------------------------------

set(handles.text14,'String','Snaga')
set(handles.text15,'String','Frekvencija')

% --------------------------------------------------------------------
function varargout = radiobutton2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.radiobutton2.
global zbir
global Dobijeno
global f

Dobijeno=[];
f=[];

set(handles.radiobutton1,'Value',0)
set(handles.radiobutton3,'Value',0)
set(handles.radiobutton4,'Value',0)

% --------------------Blok za racunanje Furijeove transformacije i faze----------------------
furije = fft(zbir,1024);
Faza = unwrap(angle(furije));%  phase
f = (0:length(furije)-1)*1024/length(furije); % Frequency vector
Dobijeno=Faza*180/pi;
plot(f,Dobijeno,'Parent',handles.axes4)
% --------------------------------------------------------------------
set(handles.text14,'String','Faza')
set(handles.text15,'String','Frekvencija')


% --------------------------------------------------------------------
function varargout = radiobutton3_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.radiobutton3.
global zbir
global Dobijeno
global f

Dobijeno=[];
f=[];


set(handles.radiobutton1,'Value',0)
set(handles.radiobutton2,'Value',0)
set(handles.radiobutton4,'Value',0)
% --------------------Blok za racunanje autokorelacije----------------------
autocor = xcorr(zbir);
f = [0:length(autocor)-1];
Dobijeno=autocor;
plot(f,Dobijeno,'Parent',handles.axes4)
% --------------------------------------------------------------------
set(handles.text14,'String','Koef. korelacije')
set(handles.text15,'String','Redni broj')


% --------------------------------------------------------------------
function varargout = radiobutton4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.radiobutton4.
global zbir
global x
global y
global Dobijeno
global f

Dobijeno=[];
f=[];


set(handles.radiobutton2,'Value',0)
set(handles.radiobutton3,'Value',0)
set(handles.radiobutton1,'Value',0)


% --------------------Blok za racunanje autokorelacije----------------------
kroscor = xcorr(x,y);
f = [0:length(kroscor)-1];
Dobijeno=kroscor;
plot(f,Dobijeno,'Parent',handles.axes4)
% --------------------------------------------------------------------
set(handles.text14,'String','Koef. korelacije')
set(handles.text15,'String','Redni broj')



% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton1.
global t
global x

figure
plot(t,x);

% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton2.
global t
global y

figure
plot(t,y);


% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton3.
global t
global zbir

figure
plot(t,zbir);




% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton4.
global Dobijeno
global f

figure
plot(f,Dobijeno);



% --------------------------------------------------------------------
function varargout = slider7_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider7.
set(handles.edit7,'String',get(handles.slider7,'Value'));
popupmenu1_Callback(h, eventdata, handles, varargin)


% --------------------------------------------------------------------
function varargout = slider8_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider8.
set(handles.edit8,'String',get(handles.slider8,'Value'));
popupmenu2_Callback(h, eventdata, handles, varargin)


% --------------------------------------------------------------------
function varargout = edit7_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit7.
set(handles.slider7,'Value',str2num(get(handles.edit7,'String')));
popupmenu1_Callback(h, eventdata, handles, varargin)


% --------------------------------------------------------------------
function varargout = edit8_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.edit8.
set(handles.slider8,'Value',str2num(get(handles.edit8,'String')));
popupmenu2_Callback(h, eventdata, handles, varargin)
